<template>
    <v-flex md12>
        <v-layout v-if="getApiImage === ''" row wrap justify-space-around>
            <v-flex md4>
                <input class="image-upload flex md12" type="file" ref="image" v-on:change="setImage()">
            </v-flex>
            <v-flex md2>
                <div class="or-picture">OU</div>
            </v-flex>
            <v-flex md4>
                <v-btn
                        class="button-picture"
                        color="#ff3d00"
                        :dark="movie.infos.title !== ''"
                        :disabled="movie.infos.title === ''"
                        @click="getImageFromApi"
                >Importer Automatiquement <br />
                    A Partir du Titre</v-btn>
            </v-flex>
        </v-layout>
        <v-layout v-else justify-center>
            <imported-file :picture_path="getApiImage" v-on:remove="deleteImageFromApi"></imported-file>
        </v-layout>
        <v-layout justify-center>
            <v-flex md11>
                <v-alert
                        :value="imageNull && !getApiImage"
                        type="info"
                        dismissible
                >
                    Veuillez sélectionner une image de couverture
                </v-alert>
            </v-flex>
        </v-layout>
    </v-flex>
</template>

<script>
    import {mapActions, mapGetters, mapMutations} from 'vuex'
    import ImportedFile from "./importedFile";
    export default {
        name: "fileUpload",
        components: {ImportedFile},
        props: ['movie'],
        data() {
            return {
                imageNull: true
            }
        },
        methods: {
            ...mapMutations({
                setApiImage: 'movieManagement/setApiImage'
            }),
            ...mapActions({
                getImageFromServer: 'movieManagement/getImageFromApi'
            }),
            setImage() {
                this.$emit('setImage', this.$refs['image'].files[0]);
                this.checkImageNotNull()
            },
            checkImageNotNull () {
                this.imageNull = (this.$refs['image'].files.length === 0);
            },
            getImageFromApi () {
                this.getImageFromServer(this.movie.infos.title)
                    .then(() => {
                        this.$emit("image-loaded")
                    })
            },
            deleteImageFromApi () {
                this.setApiImage("")
            }
        },
        computed: {
            ...mapGetters({
                getApiImage: 'movieManagement/getApiImage'
            })
        }
    }
</script>

<style scoped>
    .image-upload {
        padding: 40px;
        border: 2px solid darkorange;
        margin: 20px;
    }

    .button-picture {
        height: 60%;
        margin-top: 8%;
        margin-bottom: 5%;
    }

    .or-picture {
        padding-top: 30%;
        color: darkorange;
        font-size: 22px;
    }
</style>
